/*
 * Copyright (c) 1990. Product of Bradley University.
 * Author : Krishnakumar Siva
 */

/*
 *  lp_client.c - Open TCP connection to print files on lpr server
 *  on remote machine.  Copy all the command line files to the server
 *  queuing and print the jobs under the control of remote server
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ctype.h>
#include <signal.h>
#include <sys/in.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <errno.h>
#include <malloc.h>
#include <a.out.h>
#define ARMAG		020474
#define MAXCOPIES 	255
char 	*cfname;		/* control file */
char	*dfname;		/* data file */
char	*tfname;
char	*r_id;
char	commands[4096];
char 	*getenv();
char	*user; 
char	*jobname;
char 	*name;
char	*printer = NULL;
char	*host;
char	*hostname = "                        ";
char    *hostfile = "                        ";
char 	format = 'f';		/* format for printing */
char	*LP;
char	*RM;
char	*RP;
int 	hostid = 0;
int	cfd;			/* control file descriptor */
int	num_cmds = 0;
struct  stat	statb;
extern 	char	*LP;
extern  char	*RM;
extern  char	*RP;
char 	*SD = "/usr/spool/lp/temp/";  
int	DU = 1;
char 	*DEFAULTLP = "lp";
char	*arg;
FILE 	*fd;
int	copies = 1;
main(argc,argv)
int	argc;
char	*argv[];
{
	struct sockaddr_in 	sin,sinb; /* socket address */
	struct servent 		*hp,*bps; /* server entry */
	struct hostent		*sp,*lh;  /* host entry	  */
	int			s;	/* TCP socket	  */
	int			length;	/* length	  */
	long			address; /* IP address	  */
	int			i,f;	 /* number of copies */
	char			*mktemp();
	char			*itoa();
	void			card();
	int			pos = 0;

	name = argv[0];

	while (argc > 1 && argv[1][0] == '-') {
		argc--;
		arg = *++argv;
		switch (arg[1])  {
		
		case 'P': 		/* destination printer in 4.3 */
			if (arg[2])
				printer = &arg[2];
			break;
		case 'S':
			if (arg[2])
				host = &arg[2];
			break;
		case 'R':
			if (arg[2])
				r_id = &arg[2];
			break;
		case '#':
			if (isdigit(arg[2])) {
				i = atoi(&arg[2]);
				if (i > 0)
					copies = i;
			}
			break;
		case 'U':
			if (arg[2])
				user = &arg[2];
			break;
		case 'J':
			if (arg[2])
				jobname = &arg[2];
			break;
		}

	}
	if (printer == NULL && (printer = getenv("PRINTER"))== NULL)
		printer = DEFAULTLP;
			
	gethostname(hostname,strlen(hostname));
	strcpy(hostfile,hostname);
	strcpy(hostfile,strtok(hostfile,"."));
	cfname = mktemp("cf",5);
	dfname = mktemp("df",5);
/*
 * Get the qualified host entry for the server specified before creating
 * the card or control file 
 */
	if (isdigit(host[0])) {
		if ((address = inet_addr(host)) == -1) {
			fprintf(stderr,"%s: invalid hostname %s\n",name,host);
			exit(1);
		}
		sin.sin_addr.s_addr = address;
		sin.sin_family = AF_INET;
	}
	else if ((sp = gethostbyname(host)) == NULL)  {
		switch (errno)  {
			case HOST_NOT_FOUND:
				fprintf(stderr,"%s: no such host %s\n",name,host);
				exit(1);
			case TRY_AGAIN:
				fprintf(stderr,"%s: try again later%s\n",name,host);
				exit(1);
			default:
				fprintf(stderr,"%s: error: %d\n",name,errno);
				exit(1);
			}
	} 
	else {
		sin.sin_family = sp->h_addrtype;
		bcopy(sp->h_addr,(char *) &sin.sin_addr, sp->h_length);
	}
	if ((hp = getservbyname("printer","tcp")) == NULL)  {
		fprintf(stderr,"%s: unknown service printer\n",name);
		exit(1);
	}
	sin.sin_port = hp->s_port;
/*
 * Get client name before writing into the client file 
 */
	if (copies > 256)
		sendmail(user,9);
	card('H',hostname);
	card('P',user);
	if (jobname == NULL)  {
		if (argc == 1)
			jobname = "stdin";
		else
			jobname = argv[1];
	}
	card('J',jobname);
	card('C',hostfile);
	card('L',user);
	card('I',itoa(10));   
  
	/*
	 * Read the control files and spool them
	 */

	if (argc == 1)
		; /* nothing to print */
	else while (--argc)  {
		if ((f = test(arg = *++argv)) < 0)
		 	cleanup("");	
		if (f != -1)  {
		/* test if the file is printable */
			for (i=0;i < copies; i++)
				card(format,dfname);
			card('U',dfname);
			card('N',arg);
			if ((i = open(arg,_IOREAD)) < 0)  {
				printf("%s: cannot open %s\n",name,arg);
				continue;
			}
		}
	}
	if ((bps = getservbyname("printer","tcp")) == NULL )  {
		cleanup("Unknown Service");
	}
	sinb.sin_addr.s_addr = INADDR_ANY;
	sinb.sin_port = bps->s_port;
	if ((s = socket(AF_INET,SOCK_STREAM,0)) < 0)  {
		cleanup("Unable to create a Socket");
	}
	if (bind(s,(struct sockaddr *) &sinb,sizeof(sinb)) < 0)  {
		cleanup("Unable to bind socket");
	}
	if (connect(s,(struct sockaddr *) &sin, sizeof(sin)) < 0)  {
		cleanup("Unable to connect to remote machine");
	}
	RM = sp->h_name; 
	RP = printer;
	LP = "\0";
	openpr(s);
	sendit();	 
exit(0);
}
	
char *itoa(i)
int i;
{
	static char x[7] = "#######";
	register char *p;

	p = &x[7];
	do
		*p-- = i%10 + '0';
	while (i /= 10);
	return (++p);
}
/*
 * Test if the file requested for printing is a printable file or not
 * Return -1 if it is not, 0 if possible
 */

int test(file)
char *file;
{
	struct filehdr filehdr;
	register int fd;
	register char *cp;

	if (access(file,4) < 0)  {
		printf("%s:cannot access %s\n",name,file);
		return(-1);
	}
	if (stat(file,&statb) < 0)  {
		printf("%s:cannot stat %s\n",name,file);
		return(-1);
	}
	if ((statb.st_mode & S_IFMT) == S_IFDIR)  {
		printf("%s:%s is a directory\n",name,file);
		return(-1);
	}
	if (statb.st_size == 0)  {
		printf("%s:%s is an empty file \n",name,file);
		return(-1);
	}
	if ((fd = open(file,_IOREAD)) < 0)  {
		printf("%s:cannot open %s\n",name,file);
		return(-1);
	}
	if (read(fd,&filehdr, sizeof(filehdr)) == sizeof(filehdr))
		switch (filehdr.f_magic)  {
		case FBOMAGIC:
			printf("%s: %s is an executable program",name,file);
			(void ) close(fd);  
		 	return -1;	
		case ARMAG:
			printf("%s: %s is an archive file ",name,file);
			(void ) close(fd);  
		 	return -1;	
		}
		(void) close(fd);  
		return 0;
}	
		
void card(c,p)
register char c,*p;
{
	char buf[BUFSIZ] ;
	register char *p1 = buf;
	register int len = 2;
	sprintf(commands+strlen(commands),"%c%s\n",c,p);
}
 
cleanup(error)
char	*error;
{
	exit(1);
}


int newfile(file)
char *file;
{
	register f;
	int oldumask = umask(0);
	
	f = creat(file,0664);
	(void) umask(oldumask);
	if (f < 0)  {
		printf("%s: cannot create %s\n",name,file);
		exit(1);
		/* do actual clean i.e. unlink all the created file */
	}
	return f;
}



char *mktemp(id,num) 
char 	*id; 
int 	num;	
{ 
	char *s;
	char *malloc();
	    
	if ((s = (char *) malloc(sizeof(char) * 45 + 1)) == NULL)
		fprintf(stderr,"Out of memory");
	(void) sprintf(s,"%sA0%d%s%s",id,num,r_id,hostfile);
	return s;
}
